﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Kivii.Office.Samples
{
    public partial class FrmExcelSample : Form
    {
        //Excel启动后的程序句柄，可强制关闭
        private IntPtr _applicationHwnd = IntPtr.Zero;
        //Excel程序
        private Excel.Application _application = null;

        //Excel工作薄
        private Excel.Workbook _workbook = null;

        public FrmExcelSample()
        {
            InitializeComponent();
        }

        private void btnOpenFile_Click(object sender, EventArgs e)
        {
            OpenFileDialog ofd = new OpenFileDialog();
            ofd.Filter = "Excel文件|*.xls;*.xlsx";
            if (ofd.ShowDialog() != DialogResult.OK) return;
            tbxFilePath.Text = ofd.FileName;
        }

        private void btnStartOffice_Click(object sender, EventArgs e)
        {
            if (string.IsNullOrEmpty(tbxFilePath.Text)) { return; }
            if (_application != null) return;
            _application = new Excel.Application();
            _application.Visible = true;//可见
            _application.EnableEvents = true;
            _application.ScreenUpdating = true;
            _application.ShowWindowsInTaskbar = true;
            _application.DisplayAlerts = false;
            _application.AlertBeforeOverwriting = false;
            _applicationHwnd = new IntPtr(_application.Hwnd);//获取Excel程序句柄，防止关闭程序时，后台Excel进程不退出
            _workbook = _application.Workbooks.Open(tbxFilePath.Text, Type.Missing, false);

        }

        private void btnSetRangeValue_Click(object sender, EventArgs e)
        {
            if (_workbook == null) return;
            if (string.IsNullOrEmpty(tbxRangeName.Text) || string.IsNullOrEmpty(tbxRangeValue.Text)) return;
            //设置Sheet1的值,注意，Excel中Sheet的索引是从1开始的，不是0
            Excel.Worksheet sheet = _workbook.Sheets[1] as Excel.Worksheet;
            sheet.Cells[1, 1].Value = tbxRangeValue.Text;


        }

        private void btnSave_Click(object sender, EventArgs e)
        {
            if (_workbook == null) return;
            _workbook.Save();
        }
        private void btnClose_Click(object sender, EventArgs e)
        {
            _workbook.Close();
            _workbook = null;
        }
        private void btnExit_Click(object sender, EventArgs e)
        {
            _application.Quit();
        }


    }
}
